// Пример для одного светодиодного индикатора:                                         //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем переменную для хранения количества найденных модулей Metro.
uint8_t image_1[8];                                                                    // Объявляем массив для вывода 1 изображения. Массив имеет размер 8 байт (это строки), а в каждом байте по 8 бит (это столбцы).
uint8_t image_2[8];                                                                    // Объявляем массив для вывода 2 изображения. Массив имеет размер 8 байт (это строки), а в каждом байте по 8 бит (это столбцы).
uint8_t image_3[8];                                                                    // Объявляем массив для вывода 3 изображения. Массив имеет размер 8 байт (это строки), а в каждом байте по 8 бит (это столбцы).
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_8X8){;}                                                  // Если ближайший к Arduino модуль Metro не является светодиодным индикатором, то так же входим в бесконечный цикл while.
                                                                                       //
//  Создаём 1 изображение (телевизор):                                                 //
    image_1[0] = 0b01000100;                                                           // Верхняя строка
    image_1[1] = 0b00101000;                                                           //
    image_1[2] = 0b00010000;                                                           //
    image_1[3] = 0b11111111;                                                           //
    image_1[4] = 0b10000011;                                                           //
    image_1[5] = 0b10000011;                                                           //
    image_1[6] = 0b10000011;                                                           //
    image_1[7] = 0b11111111;                                                           // Нижняя строка
                                                                                       //
//  Создаём 2 изображение (монитор):                                                   //
    image_2[0] = 0b11111111;                                                           // Верхняя строка
    image_2[1] = 0b10000001;                                                           //
    image_2[2] = 0b10000001;                                                           //
    image_2[3] = 0b10000001;                                                           //
    image_2[4] = 0b11111111;                                                           //
    image_2[5] = 0b11111111;                                                           //
    image_2[6] = 0b00011000;                                                           //
    image_2[7] = 0b11111111;                                                           // Нижняя строка
                                                                                       //
//  Создаём 3 изображение (телефон):                                                   //
    image_3[0] = 0b01111110;                                                           // Верхняя строка
    image_3[1] = 0b11111111;                                                           //
    image_3[2] = 0b11000011;                                                           //
    image_3[3] = 0b00100100;                                                           //
    image_3[4] = 0b01111110;                                                           //
    image_3[5] = 0b01100110;                                                           //
    image_3[6] = 0b11100111;                                                           //
    image_3[7] = 0b11111111;                                                           // Нижняя строка
                                                                                       //
    delay(100);                                                                        //
                                                                                       //
}                                                                                      //
                                                                                       //
void loop(){                                                                           //
//  Выводим 1 изображение на дисплей:                                                  //
    Metro[0].on(image_1);                                                              // Выводим на дисплей изображение массива image_1.
    delay(3000);                                                                       // Ждём 3 секунды.
//  Выводим 2 изображение на дисплей:                                                  //
    Metro[0].on(image_2);                                                              // Выводим на дисплей изображение массива image_2.
    delay(3000);                                                                       // Ждём 3 секунды.
//  Выводим 3 изображение на дисплей:                                                  //
    Metro[0].on(image_3);                                                              // Выводим на дисплей изображение массива image_3.
    delay(3000);                                                                       // Ждём 3 секунды.
}                                                                                      //