// Пример для одного светодиодного индикатора:                                         //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем переменную для хранения количества найденных модулей Metro.
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_8X8){;}                                                  // Если ближайший к Arduino модуль Metro не является светодиодным индикатором, то так же входим в бесконечный цикл while.
                                                                                       //
    delay(100);                                                                        //
                                                                                       // Синтаксис функции set( "строка", скорость [, время паузы] );
    Metro[0].set("\217p\250\242e\342 Bce\254!", 240, 500);                             // Выводим строку текста "Пpивeт Bceм!" со скоростью 240 и паузой между прокрутками 500 мс. 
}                                                                                      // Обратите внимание на то, что символы Кириллицы указаны числами, это коды символов в восьмеричной системе счисления.
                                                                                       // Остальные символы можно указывать как символами, так и их кодом:
void loop(){                                                                           // пробел !?"'#$%&~^*+=-_,.:;()/|\<>[]{} 0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz
}                                                                                      //
                                                                                       //
/*  Таблица кодов символов в восьмеричной системе счисления:

  \40    0 \60    @ \100    P \120    ` \140    p \160    А \200    Р \220    а \240    р \340    Ё \360
! \41    1 \61    A \101    Q \121    a \141    q \161    Б \201    С \221    б \241    с \341    ё \361
" \42    2 \62    B \102    R \122    b \142    r \162    В \202    Т \222    в \242    т \342
# \43    3 \63    C \103    S \123    c \143    s \163    Г \203    У \223    г \243    у \343
$ \44    4 \64    D \104    T \124    d \144    t \164    Д \204    Ф \224    д \244    ф \344
% \45    5 \65    E \105    U \125    e \145    u \165    Е \205    Х \225    е \245    х \345
& \46    6 \66    F \106    V \126    f \146    v \166    Ж \206    Ц \226    ж \246    ц \346
' \47    7 \67    G \107    W \127    g \147    w \167    З \207    Ч \227    з \247    ч \347

( \50    8 \70    H \110    X \130    h \150    x \170    И \210    Ш \230    и \250    ш \350
) \51    9 \71    I \111    Y \131    i \151    y \171    Й \211    Щ \231    й \251    щ \351
* \52    : \72    J \112    Z \132    j \152    z \172    К \212    Ъ \232    к \252    ъ \352
+ \53    ; \73    K \113    [ \133    k \153    { \173    Л \213    Ы \233    л \253    ы \353
, \54    < \74    L \114    \ \134    l \154    | \174    М \214    Ь \234    м \254    ь \354
- \55    = \75    M \115    ] \135    m \155    } \175    Н \215    Э \235    н \255    э \355
. \56    > \76    N \116    ^ \136    n \156    ~ \176    О \216    Ю \236    о \256    ю \356
/ \57    ? \77    O \117    _ \137    o \157      \177    П \217    Я \237    п \257    я \357

*/