// Пример для одного звукоизлучателя:                                                  //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем переменную для хранения количества найденных модулей Metro.
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_BUZ){;}                                                  // Если ближайший к Arduino модуль Metro не является звукоизлучателем, то так же входим в бесконечный цикл while.
}                                                                                      //
                                                                                       //
void loop(){                                                                           //
//  Включаем сигнал «провал» (неудача, ошибка):                                        //
    Metro[0].on( MELODY(1) );                                                          // Зуммер однократно воспроизведёт мелодию № 1 длительностью 400 мс.
    delay(1000);                                                                       // Ждём 1 секунду.
//  Включаем сигнал «внимание»:                                                        //
    Metro[0].on( MELODY(2) );                                                          // Зуммер однократно воспроизведёт мелодию № 2 длительностью 500 мс.
    delay(1000);                                                                       // Ждём 1 секунду.
//  Включаем сигнал «успех»:                                                           //
    Metro[0].on( MELODY(3) );                                                          // Зуммер однократно воспроизведёт мелодию № 3 длительностью 400 мс.
    delay(1000);                                                                       // Ждём 1 секунду.
//  Воспроизводим фрагмент мелодии «Star Wars»:                                        //
    Metro[0].on( MELODY(4) );                                                          // Зуммер однократно воспроизведёт мелодию № 4 длительностью 10 сек.
    delay(11000);                                                                      // Ждём 11 секунд.
//  Воспроизводим 5 тональных сигналов:                                                //
    Metro[0].on(3000,200,100,5);                                                       // Воспроизводим звуковые сигналы с частотой звука 3000 Гц, длительность сигналов 200 мс, паузы между сигналами 100 мс и количество сигналов = 5.
    delay(2000);                                                                       // Ждём 2 секунды, так как воспроизведение сигналов займёт время (200мс+100мс)*5 = 1500 мс.
}                                                                                      //