																										//
#ifndef iarduino_Metro_DSL_h																			//	Функции работы с датчиком света (Digital Sensor Light).
#define iarduino_Metro_DSL_h																			//
																										//
class iarduino_Metro_DSL: public iarduino_Metro_BASE{													//	Определяем производный класс iarduino_Metro_DSL.
	public:																								//
	/**	функции данного производного класса iarduino_Metro_DSL		**/									//
	/**	дублирую функции полиморфного класса iarduino_Metro_BASE	**/									//
																										//
//		Функции не используемые в данном модуле:														//
		bool	begin			(int i0=NOT2, int i1=NOT2	){return 0;}								//	Инициализация модуля.
		int		test			(int i0=NOT2, int i1=NOT2	){return 0;}								//	Самотестирование модуля.
																										//
//		Выполняем действия:																				//
		bool	action			(int i0=NOT2, int i1=NOT2	){											//	Объявляем функцию выполнения действий.
								uint8_t data[3] = {0,0,0};												//	Определяем массив для хранения данных пакетно считываемых/записываемых в модуль.
								bool    result  = false;												//	Определяем флаг результата возвращаемый функцией action.
								uint8_t sumtry  = 100;													//	Количество попыток.
								switch(i0){																//
								//	Действие № 0 - установить значение LUX_CHANGE:						//
									case 0:																//
										do{	result	 =	objI2C.writeByte( i1, REG_DATA+3, dsl_change );	//	Записываем значение dsl_change в регистр REG_DATA+3 модуля с адресом i1.
											sumtry	--;	if(!result){delay(1);}							//	Уменьшаем количество попыток записи и устанавливаем задержку при неудаче.
										}	while		(!result && sumtry>0);							//	Повторяем запись если она завершилось неудачей, но не более sumtry попыток.
									break;																//
								//	Действие № 1 - прочитать данные из датчика освещённости:			//
									case 1:																//
										do{	result	 =	objI2C.readBytes( i1, REG_DATA, data, 3);		//	Читаем 3 байта из модуля с адресом i1, начиная с регистра REG_DATA в массив data.
											sumtry	--;	if(!result){delay(1);}							//	Уменьшаем количество попыток чтения и устанавливаем задержку при неудаче.
										}	while		(!result && sumtry>0);							//	Повторяем чтение если оно завершилось неудачей, но не более sumtry попыток.
										dsl_changed	|=	bool (	data[0] &  bit(0)	);					//	Устанавливаем флаг (не сбрасывая его) если освещённость измениласть более чем на dsl_change лк.
										dsl_lux_last =	dsl_lux;										//	Сохраняем предыдущее значение освещённости.
										dsl_lux		 =			data[2];								//	Сохраняем старший байт значения освещённости.
										dsl_lux		<<=			8;										//	Сдвигаем значение старшего байта на 8 бит влево.
										dsl_lux		+=			data[1];								//	Сохраняем младший байт значения освещённости.
									//	Устранение ложных пиков в показаниях датчика:					//
										if(dsl_lux<0)			{dsl_lux=dsl_lux_last;}					//	Освещённость не может быть отрицательной.
									//	Устранение повторных срабатываний флагов						//	Если проверить флаг в условии if() а потом прочитать данные, то флаг будет прочтён и в условии и при чтении данных, а значит сработает при следующем проходе цикла.
										if(dsl_changed){delay(20);}										//	Если установлен флаг dsl_changed «освещённость изменилась», то ждём 20 мс. В течении этого времени указанный(ые) бит(ы) будет сброшен в модуле.
									break;																//
								}																		//
								return result;															//
		}																								//
																										//
//		Получаем значение переменных:																	//
		void	setVar			(int i0=NOT2, int i1=NOT2	){											//
								switch(i0){																//
									case 0: dsl_change = i1; break;										//	Получаем значение освещённости в лк, при изменении на которое установится флаг CHANGED: 1 ... 255.
								}																		//
		}																								//
																										//
//		Возвращаем значение переменных:																	//
		long	getVar			(int i0=NOT2){															//
								bool f=0;																//	Объявляем временную переменную для вывода флагов, значение которых должно обнуляться после вывода.
								switch(i0){																//
									case 0:								  return long(dsl_lux);	break;	//	Возвращаем значение освещённости:	0 ... 65535 лк.
									case 1:	f=dsl_changed; dsl_changed=0; return long(f);		break;	//  Возвращаем флаг указывающий что значение освещённости изменилось более чем на dsl_change. Флаг dsl_changed сбрасывается после отправки своего значения.
									default:							  return 0;				break;	//
								}																		//
		}																								//
																										//
	private:																							//
	/**	Внутренние переменные **/																		//
		uint16_t	dsl_lux;																			//	Объявляем переменную для хранения показаний АЦП, это значение пропорционально углу поворота ручки потенциометра:	0 ... 255.
		uint16_t	dsl_lux_last;																		//	Объявляем переменную для хранения предыдущего значения dsl_lux
		uint8_t		dsl_change;																			//	Объявляем переменную для хранения значения АЦП, при изменении на которое установится флаг CHANGED:					1 ... 255.
		bool		dsl_changed;																		//	Объявляем переменную для хранения флага указывающего на то, что АЦП изменилось более чем на dsl_change значений.
		bool		dsl_lux_jump=false;																	//	Флаг скачка освещённости.
};																										//
																										//
#endif																									//

/* =======================================================================================================================================================================================================

Действия функций библиотеки:

read( [ параметр     ] )               - считывает все данные о потенциометре, а возвращаемое значение зависит от параметра функции (по умолчанию DSL_LUX):
        DSL_LUX                        - вернуть значение освещённости в лк снятое с датчика света (от 0 до 65535).
        DSL_CHANGED                    - вернуть флаг CHANGED регистра REG_DATA. Если данный флаг был установлен ранее, но не был прочитан, то функция read( DSL_CHANGED ) вернёт 1 вне зависимости от текущего значения флага CHANGED.
set( чувствительность )                - установка чувствительности для срабатывания флага CHANGED. Чувствительность указывается в лк от 1 до 255.

Таблица регистров модуля:

                   ╔══════════════╤══════════════╤══════════════╤══════════════╤══════════════╤══════════════╤══════════════╤══════════════╤═════════════════════════════════════════════════════════════╗
                   ║       7      │       6      │       5      │       4      │       3      │       2      │       1      │       0      │                                                             ║
                   ╠══════════════╪══════════════╪══════════════╪══════════════╪══════════════╪══════════════╪══════════════╪══════════════╪═════════════════════════════════════════════════════════════╣
0x00 REG_FLAGS_0   ║  FLG_RESET   │FLG_SELF_TEST │       -      │       -      │       -      │       -      │GET_PIN_ADDRES│GET_PIN_OUTPUT│ Служебные флаги для чтения.                                 ║
0x01 REG_BITS_0    ║  SET_RESET   │SET_SELF_TEST │       -      │       -      │       -      │       -      │       -      │SET_PIN_OUTPUT│ Служебные флаги для записи.                                 ║
0x02 REG_FLAGS_1   ║       -      │       -      │       -      │       -      │       -      │       -      │       -      │       -      │ Служебные флаги для чтения.                                 ║
0x03 REG_BITS_1    ║       -      │       -      │       -      │       -      │       -      │       -      │       -      │       -      │ Служебные флаги для записи.                                 ║
                   ╟──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┼─────────────────────────────────────────────────────────────╢
0x04 REG_MODEL   █ ║                                                             MODEL  [7-0] = 0x06 - датчик света                        │ Тип датчика                                                 ║
0x05 REG_VERSION   ║                                                             VERSION[7-0] = 0x00                                       │ Версия прошивки                                             ║
0x06 REG_ADDRESS   ║                                                             ADDRESS[6-0] = 0x09                        │ IF_PIN_ADDRES│ Текущий адрес на шине                                       ║
0x07 REG_CHIP_ID   ║                                                             CHIP_ID[7-0] = 0xC3                                       │ ID линейки чипов                                            ║
                   ╟───────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┼─────────────────────────────────────────────────────────────╢
0x08 REG_WRITE     ║                                                             WRITE_0[7-0]                                              │ Зарезервирован                                              ║
0x09 REG_WRITE+1   ║                                                             WRITE_1[7-0]                                              │ Зарезервирован                                              ║
0x0A REG_WRITE+2   ║                                                             WRITE_2[7-0]                                              │ Зарезервирован                                              ║
0x0B REG_WRITE+3   ║                                                             WRITE_3[7-0]                                              │ Зарезервирован                                              ║
0x0C REG_WRITE+4   ║                                                             WRITE_4[7-0]                                              │ Зарезервирован                                              ║
0x0D REG_WRITE+5   ║                                                             WRITE_5[7-0]                                              │ Зарезервирован                                              ║
0x0E REG_WRITE+6   ║                                                             WRITE_6[7-0]                                              │ Зарезервирован                                              ║
0x0F REG_WRITE+7   ║                                                             WRITE_7[7-0]                                              │ Зарезервирован                                              ║
                   ╟──────────────┬──────────────┬──────────────┬──────────────┬──────────────┬──────────────┬──────────────┬──────────────┼─────────────────────────────────────────────────────────────╢
0x10 REG_DATA;   █ ║       -      │       -      │       -      │       -      │       -      │       -      │       -      │   CHANGED    │ Статусные флаги                                             ║
                 █ ╟──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┴──────────────┼─────────────────────────────────────────────────────────────╢
0x11 REG_DATA+1  █ ║                                                             LUX[7-0]                                                  │ Значение освещённости снятое с датчика света (младший байт) ║
0x12 REG_DATA+2  █ ║                                                             LUX[15-8]                                                 │ Значение освещённости снятое с датчика света (старший байт) ║
0x13 REG_DATA+3  █ ║                                                             LUX_CHANGE[7-0] = 0x64 = 100 лк из 255 лк                 │ Если LUX изм. более чем на LUX_CHANGE то установится CHANGED║
                   ╚═══════════════════════════════════════════════════════════════════════════════════════════════════════════════════════╧═════════════════════════════════════════════════════════════╝
				   
CHANGED          - флаг указывает на то, что освещённость «LUX» изменились на более чем «LUX_CHANGE» значений с момента последней установки флага «CHANGED». Флаг сбрасывается аппаратно после чтения регистра REG_DATA.
LUX				 - Значение освещённости (в лк) снятое с датчика света (от 0 до 65535).
LUX_CHANGE       - Значение (от 1 до 255 лк), при изменении освещённости «LUX» на которое, установится флаг CHANGED.

*/